<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/File.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_file_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">File.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;File.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;cstdio&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">namespace </span>siggen</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;{</div>
<div class="line"><a name="l00008"></a><span class="lineno"><a class="line" href="classsiggen_1_1_file.html#a7f0e1503ea9ce5058744e7c2d8f1713f">    8</a></span>&#160;    <a class="code" href="classsiggen_1_1_file.html#a7f0e1503ea9ce5058744e7c2d8f1713f">File::File</a> (std::FILE * file)</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;        : m_File(file)</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    {</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;        <span class="keywordflow">if</span> (!m_File)</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;            <span class="keywordflow">throw</span> std::runtime_error(<span class="stringliteral">&quot;file not opened&quot;</span>);</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Opened file with handle=&quot;</span> &lt;&lt; m_File;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    }</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    File::~File ()</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    {</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keywordflow">if</span> (m_File)</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;            LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Closing file with handle=&quot;</span> &lt;&lt; m_File;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;            fclose(m_File);</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;            m_File = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        }</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    }</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="classsiggen_1_1_file.html#a0b8c2a7789ecc8fd48f9d226390fe77d">   26</a></span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classsiggen_1_1_file.html#a0b8c2a7789ecc8fd48f9d226390fe77d">File::TryRead</a> (<span class="keywordtype">char</span> * buffer, <span class="keywordtype">size_t</span> size)</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    {</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> sz = std::fread(buffer, <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>), size, m_File);</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Readed chunk from file with handle=&quot;</span> &lt;&lt; m_File &lt;&lt; <span class="stringliteral">&quot; size=&quot;</span> &lt;&lt; sz &lt;&lt; <span class="stringliteral">&quot; Bytes into buffer=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)buffer;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">return</span> sz;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    }</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classsiggen_1_1_file.html#a6ea3dc0b20f69e00366a6d8dd91d5328">   33</a></span>&#160;    <span class="keywordtype">size_t</span> <a class="code" href="classsiggen_1_1_file.html#a6ea3dc0b20f69e00366a6d8dd91d5328">File::TryWrite</a> (<span class="keywordtype">char</span> <span class="keyword">const</span> * buffer, <span class="keywordtype">size_t</span> size)</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> sz = std::fwrite(buffer, <span class="keyword">sizeof</span>(<span class="keywordtype">char</span>), size, m_File);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Wrote chunk to file with handle=&quot;</span> &lt;&lt; m_File &lt;&lt; <span class="stringliteral">&quot; size=&quot;</span> &lt;&lt; sz &lt;&lt; <span class="stringliteral">&quot; Bytes from buffer=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)buffer;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">return</span> sz;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    }</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_file_html_a6ea3dc0b20f69e00366a6d8dd91d5328"><div class="ttname"><a href="classsiggen_1_1_file.html#a6ea3dc0b20f69e00366a6d8dd91d5328">siggen::File::TryWrite</a></div><div class="ttdeci">size_t TryWrite(char const *buffer, size_t size)</div><div class="ttdoc">attempts to write block of data to file</div><div class="ttdef"><b>Definition:</b> <a href="_file_8cpp_source.html#l00033">File.cpp:33</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_file_html_a7f0e1503ea9ce5058744e7c2d8f1713f"><div class="ttname"><a href="classsiggen_1_1_file.html#a7f0e1503ea9ce5058744e7c2d8f1713f">siggen::File::File</a></div><div class="ttdeci">File(std::FILE *file)</div><div class="ttdoc">takes ownership of the opened file descriptor</div><div class="ttdef"><b>Definition:</b> <a href="_file_8cpp_source.html#l00008">File.cpp:8</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_file_html_a0b8c2a7789ecc8fd48f9d226390fe77d"><div class="ttname"><a href="classsiggen_1_1_file.html#a0b8c2a7789ecc8fd48f9d226390fe77d">siggen::File::TryRead</a></div><div class="ttdeci">size_t TryRead(char *buffer, size_t size)</div><div class="ttdoc">attempts to read block from file</div><div class="ttdef"><b>Definition:</b> <a href="_file_8cpp_source.html#l00026">File.cpp:26</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>File.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
